﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote77_MDI_CS
{
    public partial class ChildForm2 : Form
    {
        public ChildForm2()
        {
            InitializeComponent();
        }

        // 부모 폼과 관련된 라디오 버튼 값을 저장하는 변수
        private int m_piSetMainRadioSub2;
        // 외부에서 자식 폼2의 값을 접근하기 위한 속성
        public int piSetMainRadioSub2
        {
            get
            {
                // Getter 시 접근
                return m_piSetMainRadioSub2;
            }
            set
            {
                // Setter 시 접근
                m_piSetMainRadioSub2 = value;
                // 전달받은 값에 따라 UI를 변경
                switch (m_piSetMainRadioSub2)
                {
                    case 0:
                        radParent0.Checked = true;
                        break;
                    case 1:
                        radParent1.Checked = true;
                        break;
                    case 2:
                        radParent2.Checked = true;
                        break;
                    case 3:
                        radParent3.Checked = true;
                        break;
                    default:
                        break;
                }
            }
        }

        // 자식 폼과 관련된 라디오 버튼 값을 저장하는 변수
        private int m_piSetChildRadioSub2;
        // 외부에서 자식 폼2의 값을 접근하기 위한 속성
        public int piSetChildRadioSub2
        {
            get
            {
                // Getter 시 접근
                return m_piSetChildRadioSub2;
            }
            set
            {
                // Setter 시 접근
                m_piSetChildRadioSub2 = value;
                switch (m_piSetChildRadioSub2)
                {
                    case 0:
                        radChild0.Checked = true;
                        break;
                    case 1:
                        radChild1.Checked = true;
                        break;
                    case 2:
                        radChild2.Checked = true;
                        break;
                    case 3:
                        radChild3.Checked = true;
                        break;
                    default:
                        break;
                }
            }
        }

        // 부모 폼으로부터 자식 폼2을 전달받기 위한 변수와 속성. (쓰기전용)
        private ChildForm1 m_pfrmSub1;
        public ChildForm1 pfrmSub1
        {
            set
            {
                m_pfrmSub1 = value;
            }
        }

        private void ChildForm2_Load(object sender, EventArgs e)
        {
            radParent0.TabIndex = 0;
            radParent1.TabIndex = 1;
            radParent2.TabIndex = 2;
            radParent3.TabIndex = 3;
            radChild0.TabIndex = 0;
            radChild1.TabIndex = 1;
            radChild2.TabIndex = 2;
            radChild3.TabIndex = 3;
        }

        // Form 이동을 위한 Click 이벤트
        private void ChangeFormButton_Click(object sender, EventArgs e)
        {
            if (sender == btnMainForm)
            {
                smartForm1.Show(0);
            }
            else
            {
                smartForm1.Show(1);
            }
        }

        // 부모 폼 UI 변경 라디오 버튼 클릭 시 발생하는 이벤트
        private void Radio_Child_to_Main(object sender, EventArgs e)
        {
            // 클릭한 라디오 버튼에 따라 값을 설정
            m_piSetMainRadioSub2 = ((SmartX.SmartRadioButton)sender).TabIndex;

            // Owner 속성으로 부모 폼을 참조하여 값을 전달. (Setter)
            ((MainForm)(Owner)).piSetMainRadio = m_piSetMainRadioSub2;
            ((MainForm)(Owner)).piSetMainRadioSub1 = m_piSetMainRadioSub2;
        }

        // 자식 폼1 UI 변경 라디오 버튼 클릭 시 발생하는 이벤트
        private void Radio_Child_to_Child(object sender, EventArgs e)
        {
            // 클릭한 라디오 버튼에 따라 값을 설정
            m_piSetChildRadioSub2 = ((SmartX.SmartRadioButton)sender).TabIndex;

            // Owner 속성으로 부모 폼을 경유하여 자식 폼1로 값을 전달. (Setter)
            ((MainForm)(Owner)).piSetChild1Radio = m_piSetChildRadioSub2;
        }

        // 부모 폼 UI 값 Getter 클릭 시 발생하는 이벤트
        private void btnGetter1_Click(object sender, EventArgs e)
        {
            // Owner 속성으로 부모 폼을 참조하여 값을 가져옴. (Getter)
            m_piSetMainRadioSub2 = ((MainForm)(Owner)).piSetMainRadio;
            // 전달받은 값에 따라 라벨에 값 출력
            switch (m_piSetMainRadioSub2)
            {
                case 0:
                    labGetValue1.Text = "Main_radio0";
                    break;
                case 1:
                    labGetValue1.Text = "Main_radio1";
                    break;
                case 2:
                    labGetValue1.Text = "Main_radio2";
                    break;
                case 3:
                    labGetValue1.Text = "Main_radio3";
                    break;
                default:
                    break;
            }
        }

        // 자식 폼1 UI 값 Getter 클릭 시 발생하는 이벤트
        private void btnGetter2_Click(object sender, EventArgs e)
        {
            // Owner 속성으로 부모 폼을 경유하여 자식 폼1의 값을 가져옴. (Getter)
            m_piSetChildRadioSub2 = ((MainForm)(Owner)).piSetChild1Radio;
            // 전달받은 값에 따라 라벨에 값 출력
            switch (m_piSetChildRadioSub2)
            {
                case 0:
                    labGetValue2.Text = "Child1_radio0";
                    break;
                case 1:
                    labGetValue2.Text = "Child1_radio1";
                    break;
                case 2:
                    labGetValue2.Text = "Child1_radio2";
                    break;
                case 3:
                    labGetValue2.Text = "Child1_radio3";
                    break;
                default:
                    break;
            }
        }
    }
}