﻿Public Class MainForm

    ' 자식 폼1 변수
    Private m_frmChild1 As ChildForm1
    ' 자식 폼2 변수
    Private m_frmChild2 As ChildForm2
    ' 부모 폼의 라디오 버튼값을 저장할 변수
    Private m_piSetMainRadio As Integer = 0

    ' 자식 폼에서 부모 폼의 값을 참조할 속성
    Public Property piSetMainRadio() As Integer
        Get
            ' Getter 시 접근
            Return m_piSetMainRadio
        End Get
        Set(ByVal value As Integer)
            ' Setter 시 접근
            m_piSetMainRadio = value
            ' 전달받은 값에 따라 UI를 변경
            Select Case m_piSetMainRadio
                Case 0
                    radChild0.Checked = True
                Case 1
                    radChild1.Checked = True
                Case 2
                    radChild2.Checked = True
                Case 3
                    radChild3.Checked = True
                Case Else
            End Select
        End Set
    End Property

    ' 자식 폼2에서 부모 폼을 경유하여 자식 폼1의 값을 참조
    Public Property piSetChild1Radio() As Integer
        Get
            Return m_frmChild1.piSetChildRadioSub1
        End Get
        Set(ByVal value As Integer)
            m_frmChild1.piSetChildRadioSub1 = value
        End Set
    End Property

    ' 자식 폼2에서 부모 폼을 경유하여 자식 폼1의 메인폼 값을 참조
    Public Property piSetMainRadioSub1() As Integer
        Get
            Return m_frmChild1.piSetMainRadioSub1
        End Get
        Set(ByVal value As Integer)
            m_frmChild1.piSetMainRadioSub1 = value
        End Set
    End Property

    Private Sub MainForm_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 자식 폼 인스턴싱
        m_frmChild1 = New ChildForm1()
        m_frmChild2 = New ChildForm2()

        ' 자식 폼1에 참조를 전달. (Setter)
        m_frmChild1.pfrmMain = Me
        m_frmChild1.pfrmSub2 = m_frmChild2

        ' 자식 폼2에 참조를 전달. (Setter)
        m_frmChild2.pfrmSub1 = m_frmChild1

        ' 현재 Form을 MainForm으로 설정
        SmartForm1.MainForm = Me

        ' 자식 폼 추가.
        SmartForm1.AddChildForm(m_frmChild1)
        SmartForm1.AddChildForm(m_frmChild2)
        SmartForm1.Show(0)

        radChild0.TabIndex = 0
        radChild1.TabIndex = 1
        radChild2.TabIndex = 2
        radChild3.TabIndex = 3
    End Sub

    ' Form 이동을 위한 Click 이벤트
    Private Sub ChangeFormButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnChildForm2.Click, btnChildForm1.Click
        If sender Is btnChildForm1 Then
            SmartForm1.Show(1)
        Else
            SmartForm1.Show(2)
        End If
    End Sub

    ' RadioButton 클릭 시 자식 폼들에게 값을 전달. (Setter)
    Private Sub Radio_Main_to_Child(ByVal sender As Object, ByVal e As EventArgs) Handles radChild3.Click, radChild2.Click, radChild1.Click, radChild0.Click
        ' 클릭한 라디오버튼에 따라 값 설정
        m_piSetMainRadio = (CType(sender, SmartX.SmartRadioButton)).TabIndex

        ' 설정된 값을 자식 폼들에게 전달. (Setter)
        m_frmChild1.piSetMainRadioSub1 = m_piSetMainRadio
        m_frmChild2.piSetMainRadioSub2 = m_piSetMainRadio
    End Sub

    ' 자식 폼1 UI 값 Getter 버튼 클릭 시 발생하는 이벤트
    Private Sub btnGetter1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnGetter1.Click
        ' 자식 폼1의 부모 폼과 관련된 라디오 버튼값을 가져옴. (Gatter)
        Dim iSub1 As Integer = m_frmChild1.piSetMainRadioSub1

        ' 가져온 값에 따라 라벨에 텍스트를 출력
        Select Case iSub1
            Case 0
                labGetValue1.Text = "Child1_radio0"
            Case 1
                labGetValue1.Text = "Child1_radio1"
            Case 2
                labGetValue1.Text = "Child1_radio2"
            Case 3
                labGetValue1.Text = "Child1_radio3"
            Case Else
        End Select
    End Sub

    ' 자식 폼2 UI 값 Getter 버튼 클릭 시 발생하는 이벤트
    Private Sub btnGetter2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnGetter2.Click
        ' 자식 폼2의 부모 폼과 관련된 라디오 버튼값을 가져옴. (Getter)
        Dim iSub2 As Integer = m_frmChild2.piSetMainRadioSub2

        ' 가져온 값에 따라 라벨에 텍스트를 출력
        Select Case iSub2
            Case 0
                labGetValue2.Text = "Child2_radio0"
            Case 1
                labGetValue2.Text = "Child2_radio1"
            Case 2
                labGetValue2.Text = "Child2_radio2"
            Case 3
                labGetValue2.Text = "Child2_radio3"
            Case Else
        End Select
    End Sub
End Class
