﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote77_MDI_CS
{
    public partial class ChildForm1 : Form
    {
        public ChildForm1()
        {
            InitializeComponent();
        }

        // 부모 폼과 관련된 라디오 버튼 값을 저장하는 변수
        private int m_piSetMainRadioSub1;
        // 외부에서 자식 폼1의 값을 접근하기 위한 속성
        public int piSetMainRadioSub1
        {
            get
            {
                // Getter 시 접근
                return m_piSetMainRadioSub1;
            }
            set
            {
                // Setter 시 접근
                m_piSetMainRadioSub1 = value;
                switch (m_piSetMainRadioSub1)
                {
                    case 0:
                        radParent0.Checked = true;
                        break;
                    case 1:
                        radParent1.Checked = true;
                        break;
                    case 2:
                        radParent2.Checked = true;
                        break;
                    case 3:
                        radParent3.Checked = true;
                        break;
                    default:
                        break;
                }
            }
        }

        // 자식 폼과 관련된 라디오 버튼 값을 저장하는 변수
        private int m_piSetChildRadioSub1;
        // 외부에서 자식 폼1의 값을 접근하기 위한 속성
        public int piSetChildRadioSub1
        {
            get
            {
                // Getter 시 접근
                return m_piSetChildRadioSub1;
            }
            set
            {
                // Setter 시 접근
                m_piSetChildRadioSub1 = value;
                // 전달받은 값에 따라 UI를 변경
                switch (m_piSetChildRadioSub1)
                {
                    case 0:
                        radChild0.Checked = true;
                        break;
                    case 1:
                        radChild1.Checked = true;
                        break;
                    case 2:
                        radChild2.Checked = true;
                        break;
                    case 3:
                        radChild3.Checked = true;
                        break;
                    default:
                        break;
                }
            }
        }

        // 부모 폼의 참조를 전달받기 위한 변수와 속성. (쓰기전용)
        private MainForm m_pfrmMain;
        public MainForm pfrmMain
        {
            set
            {
                m_pfrmMain = value;
            }
        }

        // 자식 폼2의 참조를 전달받기 위한 변수와 속성. (쓰기전용)
        private ChildForm2 m_pfrmSub2;
        public ChildForm2 pfrmSub2
        {
            set
            {
                m_pfrmSub2 = value;
            }
        }

        private void ChildForm1_Load(object sender, EventArgs e)
        {
            radParent0.TabIndex = 0;
            radParent1.TabIndex = 1;
            radParent2.TabIndex = 2;
            radParent3.TabIndex = 3;
            radChild0.TabIndex = 0;
            radChild1.TabIndex = 1;
            radChild2.TabIndex = 2;
            radChild3.TabIndex = 3;
        }

        // Form 이동을 위한 Click 이벤트
        private void ChangeFormButton_Click(object sender, EventArgs e)
        {
            if (sender == btnMainForm)
            {
                smartForm1.Show(0);
            }
            else
            {
                smartForm1.Show(2);
            }
        }

        // 부모 폼 UI 변경 라디오 버튼 클릭 시 발생하는 이벤트
        private void Radio_Child_to_Main(object sender, EventArgs e)
        {
            // 클릭한 라디오 버튼에 따라 값을 설정
            m_piSetMainRadioSub1 = ((SmartX.SmartRadioButton)sender).TabIndex;

            // 전달받은 부모 폼 참조를 이용하여 값을 전달. (Setter)
            m_pfrmMain.piSetMainRadio = m_piSetMainRadioSub1;
            m_pfrmSub2.piSetMainRadioSub2 = m_piSetMainRadioSub1;
        }

        // 자식 폼 UI 변경 라디오 버튼 클릭 시 발생하는 이벤트
        private void Radio_Child_to_Child(object sender, EventArgs e)
        {
            // 클릭한 라디오 버튼에 따라 값을 설정
            m_piSetChildRadioSub1 = ((SmartX.SmartRadioButton)sender).TabIndex;

            // 전달받은 자식 폼2 참조를 이용하여 값을 전달. (Setter)
            m_pfrmSub2.piSetChildRadioSub2 = m_piSetChildRadioSub1;
        }

        // 부모 폼 UI 값 Getter 클릭 시 발생하는 이벤트
        private void btnGetter1_Click(object sender, EventArgs e)
        {
            // 전달받은 부모 폼 참조를 이용하여 값을 가져옴. (Getter)
            m_piSetMainRadioSub1 = m_pfrmMain.piSetMainRadio;

            // 전달받은 값에 따라 라벨에 값 출력
            switch (m_piSetMainRadioSub1)
            {
                case 0:
                    labGetValue1.Text = "Main_radio0";
                    break;
                case 1:
                    labGetValue1.Text = "Main_radio1";
                    break;
                case 2:
                    labGetValue1.Text = "Main_radio2";
                    break;
                case 3:
                    labGetValue1.Text = "Main_radio3";
                    break;
                default:
                    break;
            }
        }

        // 자식 폼2 UI 값 Getter 클릭 시 발생하는 이벤트
        private void btnGetter2_Click(object sender, EventArgs e)
        {
            // 전달받은 자식 폼2 참조를 이용하여 값을 가져옴. (Getter)
            m_piSetChildRadioSub1 = m_pfrmSub2.piSetChildRadioSub2;

            // 전달받은 값에 따라 라벨에 값 출력
            switch (m_piSetChildRadioSub1)
            {
                case 0:
                    labGetValue2.Text = "Child2_radio0";
                    break;
                case 1:
                    labGetValue2.Text = "Child2_radio1";
                    break;
                case 2:
                    labGetValue2.Text = "Child2_radio2";
                    break;
                case 3:
                    labGetValue2.Text = "Child2_radio3";
                    break;
                default:
                    break;
            }
        }
    }
}