﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote77_MDI_CS
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        // 자식 폼1 변수
        private ChildForm1 m_frmChild1;
        // 자식 폼2 변수
        private ChildForm2 m_frmChild2;
        // 부모 폼의 라디오 버튼값을 저장할 변수
        private int m_piSetMainRadio = 0;

        // 자식 폼에서 부모 폼의 값을 참조할 속성
        public int piSetMainRadio
        {
            get
            {
                // Getter 시 접근
                return m_piSetMainRadio;
            }
            set
            {
                // Setter 시 접근
                m_piSetMainRadio = value;
                // 전달받은 값에 따라 UI를 변경
                switch (m_piSetMainRadio)
                {
                    case 0:
                        radChild0.Checked = true;
                        break;
                    case 1:
                        radChild1.Checked = true;
                        break;
                    case 2:
                        radChild2.Checked = true;
                        break;
                    case 3:
                        radChild3.Checked = true;
                        break;
                    default:
                        break;
                }
            }
        }

        // 자식 폼2에서 부모 폼을 경유하여 자식 폼1의 값을 참조
        public int piSetChild1Radio
        {
            get
            {
                return m_frmChild1.piSetChildRadioSub1;
            }
            set
            {
                m_frmChild1.piSetChildRadioSub1 = value;
            }
        }

        // 자식 폼2에서 부모 폼을 경유하여 자식 폼1의 메인폼 값을 참조
        public int piSetMainRadioSub1
        {
            get
            {
                return m_frmChild1.piSetMainRadioSub1;
            }
            set
            {
                m_frmChild1.piSetMainRadioSub1 = value;
            }
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            // 자식 폼 인스턴싱
            m_frmChild1 = new ChildForm1();
            m_frmChild2 = new ChildForm2();

            // 자식 폼1에 참조를 전달. (Setter)
            m_frmChild1.pfrmMain = this;
            m_frmChild1.pfrmSub2 = m_frmChild2;

            // 자식 폼2에 참조를 전달. (Setter)
            m_frmChild2.pfrmSub1 = m_frmChild1;

            // 현재 Form을 MainForm으로 설정
            smartForm1.MainForm = this;

            // 자식 폼 추가.
            smartForm1.AddChildForm(m_frmChild1);
            smartForm1.AddChildForm(m_frmChild2);
            smartForm1.Show(0);

            radChild0.TabIndex = 0;
            radChild1.TabIndex = 1;
            radChild2.TabIndex = 2;
            radChild3.TabIndex = 3;
        }

        // Form 이동을 위한 Click 이벤트
        private void ChangeFormButton_Click(object sender, EventArgs e)
        {
            if (sender == btnChildForm1)
            {
                smartForm1.Show(1);
            }
            else
            {
                smartForm1.Show(2);
            }
        }

        // RadioButton 클릭 시 자식 폼들에게 값을 전달. (Setter)
        private void Radio_Main_to_Child(object sender, EventArgs e)
        {
            // 클릭한 라디오버튼에 따라 값 설정
            m_piSetMainRadio = ((SmartX.SmartRadioButton)sender).TabIndex;

            // 설정된 값을 자식 폼들에게 전달. (Setter)
            m_frmChild1.piSetMainRadioSub1 = m_piSetMainRadio;
            m_frmChild2.piSetMainRadioSub2 = m_piSetMainRadio;
        }

        // 자식 폼1 UI 값 Getter 버튼 클릭 시 발생하는 이벤트
        private void btnGetter1_Click(object sender, EventArgs e)
        {
            // 자식 폼1의 부모 폼과 관련된 라디오 버튼값을 가져옴. (Gatter)
            int iSub1 = m_frmChild1.piSetMainRadioSub1;

            // 가져온 값에 따라 라벨에 텍스트를 출력
            switch (iSub1)
            {
                case 0:
                    labGetValue1.Text = "Child1_radio0";
                    break;
                case 1:
                    labGetValue1.Text = "Child1_radio1";
                    break;
                case 2:
                    labGetValue1.Text = "Child1_radio2";
                    break;
                case 3:
                    labGetValue1.Text = "Child1_radio3";
                    break;
                default:
                    break;
            }
        }

        // 자식 폼2 UI 값 Getter 버튼 클릭 시 발생하는 이벤트
        private void btnGetter2_Click(object sender, EventArgs e)
        {
            // 자식 폼2의 부모 폼과 관련된 라디오 버튼값을 가져옴. (Getter)
            int iSub2 = m_frmChild2.piSetMainRadioSub2;

            // 가져온 값에 따라 라벨에 텍스트를 출력
            switch (iSub2)
            {
                case 0:
                    labGetValue2.Text = "Child2_radio0";
                    break;
                case 1:
                    labGetValue2.Text = "Child2_radio1";
                    break;
                case 2:
                    labGetValue2.Text = "Child2_radio2";
                    break;
                case 3:
                    labGetValue2.Text = "Child2_radio3";
                    break;
                default:
                    break;
            }
        }
    }
}